/////////////////////////////////////////////////////////
// Test_LambdaProblem Test

// BOOST
#include <boost/test/unit_test.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/test/floating_point_comparison.hpp>
#include <boost/function.hpp>
#include <boost/lambda/lambda.hpp>
#include <boost/lambda/bind.hpp>

// STL
#include <functional>
#include <iostream>
#include <memory>

using boost::unit_test_framework::test_suite;
using boost::unit_test_framework::test_case;
using boost::test_toolbox::close_at_tolerance;
using namespace boost::lambda;


namespace Tests
{ 
	class Base
	{
		public:
			std::string ReturnAString()
			{
				std::cout << "hi";
			}
	};
	class Derived      : public Base
	{
		public:
			void Func()
			{
				bind(Base::ReturnAString,_1);
			}
	};
	void Test_LambdaProblem()
	{
		
	}

}; // namespace Tests


struct Test_LambdaProblem_test_suite : public test_suite 
{
    Test_LambdaProblem_test_suite() : test_suite(std::string("LambdaProblem_test_suite")) 
    {
		// Create Test Cases
        test_case* LambdaProblem_test_case   = BOOST_TEST_CASE( &Tests::Test_LambdaProblem );

		// Add test cases to suite
		add( LambdaProblem_test_case,	0 );

	}
};

// Intialize the Test Suites
test_suite*
init_unit_test_suite( int argc, char * argv[] ) 
{
    // Create a Test Suite
    std::auto_ptr<test_suite> test( BOOST_TEST_SUITE( "LambdaProblem Unit Test Suite" ) );

    try 
    {													   
        test->add( new Test_LambdaProblem_test_suite( ) );
    }
    catch( boost::bad_lexical_cast& ) 
    {
        return (test_suite*)0;
    }

    return test.release();
}
